#!/usr/bin/perl
 
########################################################################
# COPYRIGHT NOTICE:
#
# Copyright 2008 FocalMedia.Net All Rights Reserved.
#
# Selling the code for this program without prior written consent 
# from FocalMedia.Net is expressly forbidden. You may not 
# redistribute this program in any shape or form.
# 
# This program is distributed "as is" and without warranty of any
# kind, either express or implied. In no event shall the liability 
# of FocalMedia.Net for any damages, losses and/or causes of action 
# exceed the total amount paid by the user for this software.
#
########################################################################

#### EDIT HERE -- FOR WINDOWS/IIS BASED INSTALLATIONS ONLY #######

$config_cgi = "../config.cgi"; ## <-- CHANGE THIS LINE TO THE FULL SERVER PATH TO config.cgi

# THE PATH ON A WINDOWS INSTALLATION WILL LOOK SOMETHING LIKE THIS:
# $config_cgi = "c:/inetpub/webpub/cgi-bin/pseek/config.cgi";

#### DO NOT CHANGE ANYTHING BELOW THIS LINE #################

#use FindBin;
#use lib $FindBin::Bin;
use CGI;
use DBI;
use acs;
use obbuild;

&get_setup;
$q = CGI->new; 


if ($q->param('fct') ne "")
	{
	acs::check_access($username, $password, $q->param('username'), $q->param('password'));
	print "Content-type: text/plain\n\n";
	}

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

if ($mysql_hostname eq ""){$dsn = "DBI:mysql:$db_name";}else{$dsn = "DBI:mysql:$db_name:$mysql_hostname:$mysql_port";}
$dbh2 = DBI->connect($dsn, $db_username, $db_password);
if ( !defined $dbh ) {die "Cannot connect to MySQL server: $DBI::errstr\n"; }

###### RECOUNT REVIEWS

$sql = "UPDATE links SET rev_no = '0' WHERE rev_no > 0";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror\n From: $update_sql";} 

######

$sql = "SELECT * FROM reviews ORDER BY lnkid";
$sth = $dbh->prepare($sql);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror\n From: $update_sql";} 

$rvcnt = (0 - 1);

while ( @row = $sth->fetchrow() )
{

if ($current_rv ne $row[2])
	{
	$rvcnt++;	
	$all_revs[$rvcnt] = "$row[2]" . "\t" . "1";
	$current_rv = $row[2];
	}
	else
	{
	($lid, $rvn) = split (/\t/, $all_revs[$rvcnt]);
	
	#print "$lid, $rvn\n";
	
	$rvn++;
	$all_revs[$rvcnt] = $lid . "\t" . $rvn;
	}
}


$sql = qq{UPDATE links SET rev_no = ? 
			 WHERE lnkid = ?};

$sth = $dbh->prepare($sql);
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror";} 

foreach $item (@all_revs)
	{
	($lid, $rvn) = split (/\t/, $item);
	#print "==> $lid - $rvn \n";
	$sth->bind_param(1, $rvn); 
	$sth->bind_param(2, $lid); 
   $sth->execute;
	$serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror - From: $sql";} 
	}

########### RECOUNT LINKS

$sel_dirs = "SELECT cid FROM dirs";
$sth = $dbh->prepare($sel_dirs);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror\n From: $update_sql";} 

	while ( @row = $sth->fetchrow() )
	{
	$current_cid = $row[0];
	
	$cat_link_numbers_sql = "SELECT COUNT(*) FROM links WHERE cid = '$current_cid'";
	$sth2 = $dbh2->prepare($cat_link_numbers_sql);
	if ( !defined $dbh2 ) {die "Cannot connect to mSQL server: $DBI::errstr\n - From: $sel_dirs"; }
	$sth2->execute;
	$serror = ""; $serror = $sth2->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror\n From: $update_sql";} 
	
	while ( @row2 = $sth2->fetchrow() ){$linknr = $row2[0];}

	print "==> Counting.. Please wait.. Found $linknr links in CATID: $current_cid\n";
	
	$update_sql = "UPDATE dirs SET ext1 = '$linknr' WHERE cid = '$current_cid'";
	$sth2 = $dbh2->prepare($update_sql);
	$sth2->execute;
	$serror = ""; $serror = $sth2->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror\n From: $update_sql";} 
	}


##################

print "Preparing to update link numbers... \n\n";


$sel_dirs = "SELECT * FROM dirs";
$sth = $dbh->prepare($sel_dirs);
$sth->execute;
$serror = ""; $serror = $sth->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror\n From: $update_sql";} 

	while ( @row = $sth->fetchrow() )
	{
	$sql = ""; $dirname = "";
		for ($ms = 2; $ms < 18; $ms++) 
		{
		if ($row[$ms] ne "")
			{
			$dirname = $dirname . "/$row[$ms]";

			$row[$ms] =~ s/'/\\'/g;
			$level = "l" . ($ms - 1);
			$sql = $sql . " ($level = '$row[$ms]') AND";
			}
		}
		$sql = substr($sql, 0, length($sql) - 3);
	
	#### GET TOTALS
	
if ($sql ne "")
{

	$get_totals_sql = "SELECT ext1 FROM dirs WHERE $sql";
	$sth2 = $dbh2->prepare($get_totals_sql);
	$sth2->execute;
	#$serror = ""; $serror = $sth2->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror\n From: $update_sql";} 
		
			$total_dir_links = 0;
			while ( @row2 = $sth2->fetchrow() )
			{
			$total_dir_links = $total_dir_links + $row2[0];
			}

}
		
	#### UPDATE LINK NUMBERS

	print "Updating $dirname - $total_dir_links links\n";

	$update_totals_sql = "UPDATE dirs SET linknrs = '$total_dir_links' WHERE cid = '$row[0]'";
	
	#print "==> $update_totals_sql \n\n";
	
	$sth2 = $dbh2->prepare($update_totals_sql);
	$sth2->execute;
	$serror = ""; $serror = $sth2->errstr; if ($serror ne "") {die "SQL Syntax Error: $serror\n From: $update_sql";} 

	}


$sth->finish;
$dbh->disconnect;

$sth2->finish;
$dbh2->disconnect;




####################################################################################

sub get_setup
{

$exists = (-e "$config_cgi");
if ($exists > 0)
	{
	open (STP, "$config_cgi");
		while (defined($line=<STP>))
			{
			if ($line =~ m/#/g)
				{
				$r = pos($line);
				$line = substr($line, 0, $r - 1);
				}
				
				$line =~ s/\n//g;
	
if ($line =~ /^DB_NAME/){$db_name = &get_setup_line($line, DB_NAME);}
if ($line =~ /^DB_USERNAME/){$db_username = &get_setup_line($line, DB_USERNAME);}
if ($line =~ /^DB_PASSWORD/){$db_password = &get_setup_line($line, DB_PASSWORD);}
if ($line =~ /^MYSQL_HOSTNAME/){$mysql_hostname = &get_setup_line($line, MYSQL_HOSTNAME);}
if ($line =~ /^MYSQL_PORT/){$mysql_port = &get_setup_line($line, MYSQL_PORT);}

if ($line =~ /^SCRIPT_URL/){$script_url = &get_setup_line($line, SCRIPT_URL);}
if ($line =~ /^ADMIN_URL/){$admin_url = &get_setup_line($line, ADMIN_URL);}
if ($line =~ /^WEB_URL/){$web_url = &get_setup_line($line, WEB_URL);}
if ($line =~ /^WEB_DIR/){$web_dir = &get_setup_line($line, WEB_DIR);}
if ($line =~ /^DATA_DIR/){$data_dir = &get_setup_line($line, DATA_DIR);}

if ($line =~ /^USERNAME/){$username = &get_setup_line($line, USERNAME);}
if ($line =~ /^PASSWORD/){$password = &get_setup_line($line, PASSWORD);}


			}
	close (STP);
	
	}
}




sub get_setup_line
{
my ($setup_line, $setup_var) = @_;
$crit = "\"";
$setup_line =~ m/$crit/g;
$r1 = pos($setup_line);
$setup_line =~ m/$crit/g;
$r2 = pos($setup_line);
$setup_line = substr($setup_line, $r1, ($r2 - $r1 - 1));
$return_val = $setup_line;
return ($return_val);
}

#### END CONFIGURATION ########################################################

